/********************************************************************************/
/*										*/
/* m!.cmd  Beta version 0.4  by Wolfgang Reinken				*/
/*										*/
/* m! is a text based MIDI player written in REXX using the MCI REXX functions	*/
/* M! is similar to the great mpeg player z!					*/
/* 										*/
/* - disclaimer - 								*/
/* this program comes with absolutely no guarantees. any problems, side effects,*/
/* or whatever is your responsibility.						*/
/*										*/
/* Comments are welcome: wolfgang.reinken@t-online.de				*/
/*										*/
/********************************************************************************/

"@echo off"
"mode 80,25"

/* ---------------------------------------------------------------------------- */
/* Bedeutung einiger globaler Variablen:					*/
/*										*/
/* HS			Schalter "Zeige Hauptschirm"   				*/
/*			 	    1=Haupschirm	  			*/
/*			 	    2=Hilfeschirm	  			*/
/* KeyStr		Rckgabewert von RxKbdCharIn				*/
/*         		  return code from KbdCharIn(), and, if zero, 		*/
/* 			  followed by these blank delimited values:		*/
/*       		  1) Character						*/
/*       		  2) Scan Code (hex)					*/
/*       		  3) NLS state (hex)					*/
/*        		  4) NLS shift (hex)					*/
/*       		  5) Shift Key state (hex)				*/
/*       		  6) Millisecond timestamp of keystroke			*/
/* c, plc 		Parameter 1) von KeyStr im Haupt- bzw. Abspielschirm	*/
/* s, pls 		Parameter 2) von KeyStr im Haupt- bzw. Abspielschirm	*/
/* sk, plsk 		Parameter 5) von KeyStr im Haupt- bzw. Abspielschirm	*/
/* ai			erster anzuzeigender Verzeichniseintrag			*/
/* ci			Position Balken-Cursor					*/
/* ix			lokale Hilfsvariable fr Pointer			*/
/* iLied		aktuell abzuspielendes Lied				*/
/* DatTag		Playlist-Vektor						*/
/* DatTag.0		Gre Playlist-Vektor = Anzahl getaggter Lieder		*/
/* ---------------------------------------------------------------------------- */



/* ---------------------------------------------------------------------------- */
/* Laden der Dienstprogrammroutinen						*/
/* ---------------------------------------------------------------------------- */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs
call rxfuncadd 'rxydbautilinit','ydbautil','rxydbautilinit'
call rxydbautilinit
Call RXFUNCADD "mciRxInit", "MCIAPI", "mciRxInit"

Call mciRxInit

signal on HALT name Abort

/* ---------------------------------------------------------------------------- */
/* Bildschirmaufbau								*/
/* ---------------------------------------------------------------------------- */

f0='1b'X'[0;37;40m'			/* grau auf schwarz       */
f1='1b'X'[1;31;41m'			/* hellrot auf dunkelrot  */
f2='1b'X'[1;37;41m'			/* wei auf dunkelrot 	  */
f3='1b'X'[1;33;41m'			/* gelb auf dunkelrot 	  */
f4='1b'X'[0;37;41m'			/* grau auf dunkelrot 	  */
f5='1b'X'[0;30;41m'			/* schwarz auf dunkelrot  */
f6='1b'X'[1;31;44m'			/* hellrot auf dunkelblau */
f7='1b'X'[0;37;44m'			/* grau auf dunkelblau    */
f8='1b'X'[0;30;44m'			/* schwarz auf dunkelblau */
f9='1b'X'[1;31;40m'			/* rot auf schwarz	  */
f10='1b'X'[1;34;40m'			/* blau auf schwarz	  */
f11='1b'X'[1;37;40m'			/* wei auf schwarz	  */
f12='1b'X'[1;36;40m'			/* trkis auf schwarz	  */
f13='1b'X'[1;32;40m'			/* grn auf schwarz	  */
f14='1b'X'[1;32;41m'			/* grn auf dunkelrot	  */
f15='1b'X'[1;32;44m'			/* grn auf blau	  */
f16='1b'X'[0;34;40m'			/* dunkelblau auf schwarz */
f17='1b'X'[0;31;40m'			/* dunkelrot auf schwarz  */
f18='1b'X'[0;36;40m'			/* dunkeltrkis auf schwarz  */
f19='1b'X'[1;30;40m'			/* dunkelgrau auf schwarz  */
f20='1b'X'[1;36;41m'			/* trkis auf dunkelrot	  */
f21='1b'X'[0;36;41m'			/* dunkeltrkis auf dunkelrot */
f22='1b'X'[1;37;44m'			/* wei auf dunkelblau 	  */
f23='1b'X'[1;35;40m'			/* pink auf schwarz	  */
f24='1b'X'[0;35;40m'			/* dunkelpink auf schwarz */
f25='1b'X'[1;34;41m'			/* blau auf dunkelrot	  */


  v.0=f19''
  v.5=f18''f19''
 v.10=f18''f19''
 v.15=f18''f19''
 v.20=f18''f19''
 v.25=f18''f19''
 v.30=f18''f19''
 v.35=f18''f19''
 v.40=f18''f19''
 v.45=f18''f19''
 v.50=f18''f19''
 v.55=f18''f13''f19''
 v.60=f18''f13''f19''
 v.65=f18''f13''f19''
 v.70=f18''f13''f19''
 v.75=f18''f13''f19''
 v.80=f18''f13''f19''
 v.85=f18''f13''f9''f19''
 v.90=f18''f13''f9''f19''
 v.95=f18''f13''f9''
v.100=f18''f13''f9''

DatTag.0=0
volume=75		/* Voreinstellung Lautstrke=70%	*/
AnzMid=0		/* Voreinstellung Midi-Dateien		*/
SuchFeld=''		/* Voreinstellung fr Vergleichsfeld SuchVerzDatLw */
PlayForever=0		/* Voreinstellung Schalter Play Forever	*/
PlayRandom=0		/* Voreinstellung Schalter Play Random	*/
pauspl=0		/* Voreinstellung Schalter Spielpause	*/

call SysCurState 'OFF'
call SysCls
call DisplayHead
/* ---------------------------------------------------------------------------- */
/* erstes Verzeichnis einlesen und anzeigen					*/
/* ---------------------------------------------------------------------------- */

AnfVerz=directory()
call LesAktVerz
ai=1			/* erster anzuzeigender Verzeichniseintrag	*/
call AnzPWD
call AnzAktVerz ''
ci=1			/* Position Balken-Cursor			*/
call AnzCurBalk

/* ---------------------------------------------------------------------------- */
/* Hauptzyklus									*/
/* ---------------------------------------------------------------------------- */

HS=1				/* Schalter "Zeige Hauptschirm"   */
				/* 	    1=Haupschirm	  */
				/* 	    2=Hilfeschirm	  */

do until (c='1B'X | c='03'X) & HS=1
  KeyStr = RxKbdCharIn(wait)		/* Eingabe eines Zeichens ohne Echo mit Auswertung Scancode */
  if substr(KeyStr,2,2)='  ' then 
  do
    c=translate(word(KeyStr,1))	/* eingegebenes Zeichen 	*/
    s=translate(word(KeyStr,2))	/* eingegebener Scancode	*/
    sk=word(KeyStr,5)
  end
  else 
  do
    c=translate(word(KeyStr,2))	/* eingegebenes Zeichen 	*/
    s=translate(word(KeyStr,3))	/* eingegebener Scancode	*/
    sk=word(KeyStr,6)
  end
  if substr(KeyStr,2,3)='   ' then c=' '
  SKpr=substr(x2b(right(sk,4,'0')),15,1)=1|substr(x2b(right(sk,4,'0')),16,1)=1      /* Shift Key gedrckt? */
  ix=ai-1+ci
  select
    when HS=2 & s <> '00' then 	/* Wechseln zu Hauptschirm	*/
      do
	HS=1
	call DisplayHead    
	call AnzAktVerz
	call AnzPWD
	call AnzCurBalk
        c='00'X /* Unterdrckung Abbruch */
      end
    when ((c>='A' & c<='Z') | (c>='0' & c<='9') | pos(c,':.-_')>0) & SKpr=1 then    /* Buchst., Ziffer mit Shift */
      call SuchVerzDatLw c
    when c='L' & SKpr=0 then call LoadPlayList	9,40,f2,f25'.'	/* L ohne Shift				*/
    when c='S' & SKpr=0 then call SavePlayList	9,40,f2,f25'.'	/* S ohne Shift				*/
    when c='C' & SKpr=0 then call ClearPlayList			/* C ohne Shift				*/
    when c='A' & SKpr=0 then call TagUntagAllVerz	/* A ohne Shift (Tag/Untag alle)		*/
    when c=' ' & DTyp.ix='F' then call TagUntag 0	/* <SPACE> bei MIDI-Datei (Tag/Untag Datei)	*/
    when c='F' & SKpr=0 then call HZtogForever	/* F ohne Shift (Toggle Play Forever)		*/
    when c='R' & SKpr=0 then call HZtogRandom	/* F ohne Shift (Toggle Random Playback)	*/
    when c='0d'X & DTyp.ix='F' | c='P' & SKpr=0 & DatTag.0>0 then	/* <ENTER> bei MIDI-Datei oder 'P' ohne Shift: Abspielen */
      do
        if SuchFeld<>'' then do; SuchFeld=''; call SysCurPos 23,20; call charout ,f5''; end
        if DatTag.0=0 then do; DatTag.0=1; DatTag.1=datei.ix; DTag.ix=1; end
        if PlayRandom=1 then call Mischen
	AS=1
        do until PlayForever=0
          iLied=1
	  do while iLied <= DatTag.0   
	    select
	      when AS=1 then call DisplayHeadPlay iLied		/* Status Abspielschirm	*/
	      when AS=0 then do; call AnzAktVerz DatTag.iLied; call AnzCurBalk; end /* Auffrischen Hauptschirm */
	      otherwise
	    end
	    call Abspielen DatTag.iLied
	    if DatTag.0=0 | plc='B' then leave
	    iLied=iLied+1
	  end
	end
	if iLied>DatTag.0 | plc='1B'X | plc='Q' then call UntagAll
        call DisplayHead    
	call AnzAktVerz ''
	call AnzPWD
	call AnzCurBalk
      end
    when s='4B' then call HZleft	/* <LEFT> 			*/
    when (c='0d'X | s='4D') & DTyp.ix<>'F' then	call HZchdir /* <ENTER> oder <RIGHT> bei Dir und Drive */
    when s='50' then call HZdown	/* <DOWN>			*/
    when s='48' then call HZup		/* <UP>				*/
    when s='51' then call HZpgdn	/* <PGDN>			*/
    when s='49' then call HZpgup	/* <PGUP>			*/
    when s='47' then call HZhome	/* <HOME>			*/
    when s='4F' then call HZend		/* <END>			*/
    when s='3B' then call HZhelp	/* Wechseln zu Hilfeschirm	*/
    otherwise
  end
end

  call directory AnfVerz
  call charout ,f0
  call mciRxExit 
exit 

Abort:
  rc = mciRxSendString('close m wait', 'RetStr', '0', '0')
  call directory AnfVerz
  call charout ,f0
  call mciRxExit 
exit 

AnzPWD:

  /*							*/
  /* Anzeige aktueller Verzeichnispfad			*/
  /*							*/
  AktDir=directory()
  call charout ,f1
  call SysCurPos 8,0; call charout ,' '||copies('',76)||' '
  call charout ,f4
  call SysCurPos 8,6; call charout ,' Current Directory: ['Aktdir'] '

return

/* ---------------------------------------------------- */
/* Aufbau des Vektors DATEI.X durch Aufnahme		*/
/* - der Unterverzeichnisse				*/
/* - der MIDI-Dateien					*/
/* - der lokalen Laufwerke				*/
/* ---------------------------------------------------- */

LesAktVerz:

  dn=1					/* Anzahl der Dateieintrge */
  /*							*/
  /* Aufnahme Der Unterverzeichnisse (DTyp=D)		*/
  /*							*/
  Datei.dn='.. (Parent Directory)'
  DTyp.dn='D'
  call SysFileTree '*', DateiAlle, 'OD'	/* Lesen der Verzeichnisse  */
  do lvi=1 to DateiAlle.0
    dn=dn+1
    Datei.dn=DateiAlle.lvi
    DTyp.dn='D'
  end
  /*							*/
  /* Aufnahme der MIDI-Dateien (DTyp=F)			*/
  /*							*/
  AnzMid=0
  call SysFileTree '*', DateiAlle, 'F'	/* Lesen der Dateien  */
  do lvi=1 to DateiAlle.0
    type = ""
    if  SysGetEA(subword(DateiAlle.lvi,5), ".type", "TYPEINFO") = 0 then 
    do
      parse var typeinfo 11 type
    end
    if translate(substr(DateiAlle.lvi,length(DateiAlle.lvi)-3,4))=".MID" then type="MIDI"
    if type="MIDI" then
    do
      dn=dn+1
      AnzMid=AnzMid+1
      Datei.dn=subword(DateiAlle.lvi,5)
      DSiz.dn=word(DateiAlle.lvi,3)
      if word(DateiAlle.lvi,3)>999 then DSiz.dn=insert('.',DSiz.dn,length(DSiz.dn)-3)
      if word(DateiAlle.lvi,3)>999999 then DSiz.dn=insert('.',DSiz.dn,length(DSiz.dn)-7)
      DTyp.dn='F'
      DTag.dn=0		/* Status "untagged"	*/
      do lvj=1 to DatTag.0
        if Datei.dn=DatTag.lvj then DTag.dn=1
      end
    end
  end
  /* Anzahl MIDI-Dateien			*/
  call SysCurPos 4,3; call charout ,f5'xxxxx'
  call SysCurPos 4,8-length(AnzMid); call charout ,f2||AnzMid
  /*							*/
  /* Aufnahme der lokalen Laufwerke (DTyp=V)		*/
  /*							*/
  AlleLw=SysDriveMap()
  do lvi=1 to words(AlleLw)
    dn=dn+1
    Datei.dn=word(AlleLw,lvi)
    DTyp.dn='V'
  end
  
return

/* ---------------------------------------------------- */
/* Anzeige von max. 10 Zeilen des Vektors DATEI.X	*/
/* - Beginn bei Zeile "ai"				*/
/* - Kennzeichnung von Verzeichnissen, Dateigren	*/
/*   und Laufwerken					*/
/* ---------------------------------------------------- */

AnzAktVerz:

  parse arg AALied

  do avi=1 to 10
    ix=ai-1+avi
    call SysCurPos 11+avi,5; call charout ,f1||'  ô '
    DatNam=filespec('name',Datei.ix)
    DatNam=left(substr(DatNam,1,min(47,length(DatNam)))' 'f5,58,'.')
    select
      when ai-1+avi<=dn & DTyp.ix='D' 
        then call charout ,f4||DatNam'xxx'f4'<Dir>'f5'xxx'
      when ai-1+avi<=dn & DTyp.ix='F' then 
        do
	  call charout ,f4||DatNam'xxxxxxxxxxx'; 
	  call SysCurPos 11+avi,70-length(DSiz.ix)
 	  call charout ,f4||DSiz.ix
	  if DTag.ix=1 then 
	  do
	    call SysCurPos 11+avi,7
	    if AALied=datei.ix then call charout ,f2
			       else call charout ,f14
	    call charout ,''
	  end
	end
      when ai-1+avi<=dn & DTyp.ix='V' 
        then call charout ,f4||left(Datei.ix' 'f5,58,'.')'xx'f4'<Drive>'f5'xx'
      otherwise
        call charout ,f4||left(' ',59)
    end
    call SysCurPos 11+avi,70; call charout ,f1||'   '
  end
return

/* ---------------------------------------------------- */
/* Anzeige Cursorbalken (blauer Grund)			*/
/* ---------------------------------------------------- */

AnzCurBalk:

  call charout ,f6
  call SysCurPos 11+ci,5
  call charout ,'  ô'||copies(' ',60)||'   '
  call charout ,f7
  ix=ai-1+ci
  DatNam=filespec('name',Datei.ix)
  DatNam=left(substr(DatNam,1,min(47,length(DatNam)))' 'f8,58,'.')
  select
    when DTyp.ix='D' then
      do; call SysCurPos 11+ci,11; call charout ,DatNam'xxx'f7'<Dir>'f8'xxx'; end
    when DTyp.ix='F' then 
      do
	call SysCurPos 11+ci,11
	call charout ,DatNam'xxxxxxxxxxx'; 
	call SysCurPos 11+ci,70-length(DSiz.ix)
	call charout ,f7||DSiz.ix
	if DTag.ix=1 then 
	do
	  call SysCurPos 11+ci,7
	  if AbspielDatei=datei.ix then call charout ,f22
				   else call charout ,f15
	  call charout ,''
	end
      end
    when DTyp.ix='V' then
      do; call SysCurPos 11+ci,11; call charout ,left(Datei.ix' 'f8,58,'.')'xx'f7'<Drive>'f8'xx'; end
    otherwise
  end


return

/* ---------------------------------------------------- */
/* Rcksetzen des alten Cursorbalkens auf Normalfarbe	*/
/* ---------------------------------------------------- */

ResCurBalk:

  call charout ,f1
  call SysCurPos 11+ci,5
  call charout ,'  ô'||copies(' ',60)||'   '
  call charout ,f4
  ix=ai-1+ci
  DatNam=filespec('name',Datei.ix)
  DatNam=left(substr(DatNam,1,min(47,length(DatNam)))' 'f5,58,'.')
  select
    when DTyp.ix='D' then
      do; call SysCurPos 11+ci,11; call charout ,DatNam'xxx'f4'<Dir>'f5'xxx'; end
    when DTyp.ix='F' then
      do
	call SysCurPos 11+ci,11
	call charout ,DatNam'xxxxxxxxxxx'; 
	call SysCurPos 11+ci,70-length(DSiz.ix)
	call charout ,f4||DSiz.ix
	if DTag.ix=1 then 
	do
	  call SysCurPos 11+ci,7
	  if AbspielDatei=datei.ix then call charout ,f2
				   else call charout ,f14
	  call charout ,''
	end
      end
    when DTyp.ix='V' then
      do; call SysCurPos 11+ci,11; call charout ,left(Datei.ix' 'f5,58,'.')'xx'f4'<Drive>'f5'xx'; end
    otherwise
  end

return

/* ---------------------------------------------------- */
/* Anzeige statische Informationen Hauptschirm		*/
/* ---------------------------------------------------- */

DisplayHead:

  call SysCls
  call charout ,f1
  call SysCurPos 24,78
  call charout ,'    '
  call SysCurPos 0,0
  call charout ,' '||copies('',76)||' '
  call charout ,' '||copies(' ',76)||' '
  call charout ,' '||copies('',76)||' '
  call charout ,'  'f3'Statistics'f1' Ŀ'
  call charout ,'  'f3'Selection Options'f1' Ŀ'
  call charout ,'  'f3'Play Options'f1' Ŀ '
  call charout ,'  'f5'xxxxx 'f4'MIDI listed'f1'  '
  call charout ,'    'f2'A'f1'    'f4'tag/untag 'f2'A'f4'll'f1'       '
  call charout ,'   'f2'P'f1'   'f2'P'f4'lay tagged'f1'    '
  call charout ,'  'f5'xxxxx 'f4'MIDI tagged'f1'  '
  call charout ,'  'f2'Space'f1'  'f4'tag/untag hilited'f1'   '
  call charout ,'   'f2'R'f1'   'f2'R'f4'andom play'f1'    '
  call charout ,' '
  call charout ,'  'f2'Alt-R'f1'  'f4'recursive tag'f1'       '
  call charout ,'   'f2'F'f1'   'f4'play 'f2'F'f4'orever'f1'   '
  call charout ,'                       '
  call charout ,' '
  call charout ,'  '
  call charout ,' '||copies('',76)||' '
  do dhi=1 to 15
    call charout ,' '||copies(' ',76)||' '
  end
  call charout ,' '||copies('',76)||''
  call charout ,f5
  call SysCurPos 10,3
  call charout ,''||copies('',72)||''
  do dhi=1 to 12
    call SysCurPos 10+dhi,3
    call charout ,''||copies(' ',72)||''
  end
  call SysCurPos 10+dhi,3
  call charout ,''||copies('',72)||''
  call charout ,f1
  call SysCurPos 11,6
  call charout ,'Ŀ'||copies('',60)||'Ŀ'
  do dhi=1 to 10
    call SysCurPos 11+dhi,6
    call charout ,' ô'||copies(' ',60)||'  '
  end
  call SysCurPos 11+dhi,6
  call charout ,''||copies('',60)||''
  call charout ,f3
  call SysCurPos 10,5; call charout ,' Tag '
  call SysCurPos 10,28; call charout ,f2''f3' Filename 'f2''f3
  call SysCurPos 10,60; call charout ,' Filesize '
  call charout ,f4
  call SysCurPos 1,10
  call charout ,'M! v0.4 - MIDI PLAYER FOR OS/2 - BY Wolfgang Reinken'
  /* Anzahl MIDI-Dateien		*/
  call SysCurPos 4,3; call charout ,f5'xxxxx'
  call SysCurPos 4,8-length(AnzMid); call charout ,f2||AnzMid
  /* Anzahl geTAGgter Dateien		*/
  call SysCurPos 5,3; call charout ,f5'xxxxx'
  call SysCurPos 5,8-length(DatTag.0); call charout ,f2||DatTag.0
  /* Anzeige Play Forever 		*/
  call AnzPlayForeverRandom

return

/* ---------------------------------------------------- */
/* Anzeige statische Infos Abspielschirm		*/
/* ---------------------------------------------------- */

DisplayHeadPlay:

  parse arg ptrLied

  call SysCls
  call charout ,f9'Ϳ'
  call charout ,f9''f0'۲ M! v.0.4  midi player for OS/2!  'f9''
  call charout ,f9''f0' by Wolfgang Reinken 'f9''
  say
  say f12' p'f10'laying 'f12'f'f10'ile'f13':'
  call SysCurPos 8,0
  say f12' t'f10'otal 'f12'p'f10'laying 'f12't'f10'ime ['f0''f13':'f0''f10']'
  say f12' t'f10'ime 'f12'e'f10'lapsed       ['f0''f13':'f0''f10']'
  call SysCurPos 15,0
  say f16' ['f9'P'f16']'
  say f19'  -'f12'p'f10'revious 'f12's'f10'ong'f13':'
  say      f12'       a'f10'ctual 'f12's'f10'ong'f13':'
  say f19'  -'f12'n'f10'ext 'f12's'f10'ong'f13':'
  say f16' ['f9'N'f16']'
  call SysCurPos 15,20; if ptrLied>2 then do; ptr=ptrLied-2; call charout ,f19||left(substr(DatTag.ptr,1,59),59); end
  call SysCurPos 16,20; if ptrLied>1 then do; ptr=ptrLied-1; call charout ,f19||left(substr(DatTag.ptr,1,59),59); end
  call SysCurPos 17,20; if ptrLied>0 then do; ptr=ptrLied-0; call charout ,f11||left(substr(DatTag.ptr,1,59),59); end
  call SysCurPos 18,20; if DatTag.0-ptrLied+1>1 then do; ptr=ptrLied+1; call charout ,f19||left(substr(DatTag.ptr,1,59),59); end
  call SysCurPos 19,20; if DatTag.0-ptrLied+1>2 then do; ptr=ptrLied+2; call charout ,f19||left(substr(DatTag.ptr,1,59),59); end

  call SysCurPos 22,0
  say f16' ['f9'Q'f16']'
  say f19'  -'f12'q'f10'uit 'f12'b'f10'ack 'f12't'f10'o 'f12'f'f10'ile 'f12'l'f10'isting'
  call SysCurPos 10,20; call charout ,f16'['f9'< 'f19''f9' >'f16']'
  call SysCurPos 22,42; call charout ,f16'['f17'<'f9'space'f17'>'f16']'
  if pauspl=0
    then do; call SysCurPos 23,42; call charout ,f0'    -'f12'p'f10'ause 'f12'p'f10'layback'; end
    else do; call SysCurPos 23,42; call charout ,f0'    -'f12'r'f10'esume 'f12'p'f10'layback'; end
  call SysCurPos 24,68; call charout ,f19'('f18'f1'f19'='f18'help'f19')'
  call SysCurPos 8,51; call charout ,f12'v'f10'olume'f13': 'f11'  0'f13'%'
  call SysCurPos 9,51; call charout ,f16'[          ]'
  call SysCurPos 10,51; call charout ,f16'['f9'<'f17'- 'f19'-- 'f17'-'f9'>'f16']'
  call SysCurPos 12,1;  call charout ,f19'[]'
  ElaPosA=0		/* Merkwert fr altes ElaPos 	*/
  if pauspl=0
    then do; call SysCurPos 12,2+ElaPosA; call charout ,f12''; end
    else do; call SysCurPos 12,2+ElaPosA; call charout ,f18''; end
return

/* ---------------------------------------------------- */
/* Abspielen einer MIDI-Datei				*/
/* ---------------------------------------------------- */

Abspielen:

  parse arg AbspielDatei

  /*AS=1*/			/* Schalter "Zeige Abspielschirm" 	  */
				/* 	    0=Haupschirm	  	  */
				/* 	    1=Abspielschirm	  	  */
				/* 	    2=Hilfeschirm zu Abspielen	  */
				/* 	    3=Hilfeschirm zu Hauptschirm  */

  rc = mciRxSendString('open sequencer alias m shareable wait', 'RetStr', '0', '0')
  if rc <> 0 then
  do
     MacRC = mciRxGetErrorString(rc, 'ErrStVar')
     say 'OPEN: rc =' rc ', ErrStVar =' ErrStVar
     wt=SysGetKey(noecho)
  end

  rc = mciRxSendString('load m "'AbspielDatei'" wait', 'RetStr', '0', '0')
  if rc <> 0 then
  do
     MacRC = mciRxGetErrorString(rc, 'ErrStVar')
     say 'LOAD: rc =' rc ', ErrStVar =' ErrStVar
     rc = mciRxSendString('release m return ressource', 'RetStr', '0', '0')
     wt=SysGetKey(noecho)
  end
  else
  do
    rc = mciRxSendString('set m time format milliseconds wait', 'RetStr', '0', '0')
    rc = mciRxSendString('status m length wait', 'RetStr', '0', '0')
    LenPlay=RetStr%1000; LenSec=LenPlay//60+100; LenMin=LenPlay%60
    if AS=1 then
    do
      call SysCurPos 8,24; call charout ,f11||substr(LenSec,2,2)
      if LenMin<10 then do; call SysCurPos 8,22; call charout ,f11||LenMin; end
      		   else do; call SysCurPos 8,21; call charout ,f11||LenMin; end
      call SysCurPos 5,5; call charout ,f11||filespec("name",AbspielDatei)
    end
    rc = mciRxSendString('play m', 'RetStr', '0', '0')
    if rc <> 0 then
    do
       MacRC = mciRxGetErrorString(rc, 'ErrStVar')
       say 'PLAY: rc =' rc ', ErrStVar =' ErrStVar
       wt=SysGetKey(noecho)
    end
    elaps=0		/* elapsed time des Liedes	*/
    pauspl=0		/* Abspiele unterbrochen (=1)	*/
    rc = mciRxSendString('set m volume 'volume' wait', 'RetStr', '0', '0');
    if AS=1 then
    do
      call SysCurPos 8,59; call charout ,f11||right(volume,3)
      call SysCurPos 9,52; call charout ,v.volume
    end
    do until StatStr<>"playing" & StatStr<>"paused"
      KeyStr = RxKbdCharIn(nowait)
      abspix=ai-1+ci
      if substr(KeyStr,2,2)='  ' then 
      do
        plc=translate(word(KeyStr,1))	/* eingegebenes Zeichen 	*/
        pls=translate(word(KeyStr,2))	/* eingegebener Scancode	*/
        plst=word(KeyStr,3)		/* Status (00=kein Zeichen)	*/
	plk=word(KeyStr,5)
      end
      else 
      do
        plc=translate(word(KeyStr,2))	/* eingegebenes Zeichen 	*/
        pls=translate(word(KeyStr,3))	/* eingegebener Scancode	*/
        plst=word(KeyStr,4)		/* Status (00=kein Zeichen)	*/
	plk=word(KeyStr,6)
      end
      if substr(KeyStr,2,3)='   ' then plc=' '
      plSKpr=substr(x2b(right(plk,4,'0')),15,1)=1|substr(x2b(right(plk,4,'0')),16,1)=1 /* Shift Key? */
      select
        when AS=1 & (plc='1b'X | plc='Q') then 	/* Abbruch des Abspielens	*/
	  do
            rc = mciRxSendString('stop m wait', 'RetStr', '0', '0');
	    DatTag.0=0
	    PlayForever=0
	  end
        when AS=1 & (plc='B') then	 	/* Abbruch des Abspielens ohne Lschen Playlist */
	  do
            rc = mciRxSendString('stop m wait', 'RetStr', '0', '0');
	    PlayForever=0
	  end
        when AS=1 & plc='N' then 	/* Nchstes Lied		*/
	  do
            rc = mciRxSendString('stop m wait', 'RetStr', '0', '0');
	  end
        when AS=1 & plc='P' & DatTag.0>1 then 	/* Voriges Lied			*/
	  do
            rc = mciRxSendString('stop m wait', 'RetStr', '0', '0');
            iLied=max(0,iLied-2)
	  end
        when AS=1 & plc='<' then 	/* 5s rckwrts			*/
	  do
            if elaps>5 then elaps=elaps-5
	               else elaps=0
	    call AnzElaps
            rc = mciRxSendString('seek m to 'elaps*1000' wait', 'RetStr', '0', '0');
	    rc = mciRxSendString('set m volume 'volume' wait', 'RetStr', '0', '0');
            rc = mciRxSendString('play m', 'RetStr', '0', '0')
          end
        when AS=1 & plc='>' then 	/* 5s vorwrts			*/
	  do
            if elaps<LenPlay-5 then elaps=elaps+5
	               	       else elaps=LenPlay
	    call AnzElaps
            rc = mciRxSendString('seek m to 'elaps*1000' wait', 'RetStr', '0', '0');
	    rc = mciRxSendString('set m volume 'volume' wait', 'RetStr', '0', '0');
            rc = mciRxSendString('play m', 'RetStr', '0', '0')
          end
        when AS=1 & pls='4B' then 	/* Volume leiser		*/
	  do
            if Volume>0 then volume=volume-5
            rc = mciRxSendString('set m volume 'volume' wait', 'RetStr', '0', '0');
	    call SysCurPos 8,59; call charout ,f11||right(volume,3)
	    call SysCurPos 9,52; call charout ,v.volume
          end
        when AS=1 & pls='4D' then 	/* Volume lauter		*/
   	  do
            if Volume<100 then volume=volume+5
            rc = mciRxSendString('set m volume 'volume' wait', 'RetStr', '0', '0');
	    call SysCurPos 8,59; call charout ,f11||right(volume,3)
	    call SysCurPos 9,52; call charout ,v.volume
	  end
        when AS=1 & plc=' ' then 	/* Unterbrechen des Abspielens	*/
          do
            if pauspl=0 then
  	    do
  	      call SysCurPos 12,2+ElaPos; call charout ,f18''
              rc = mciRxSendString('pause m wait', 'RetStr', '0', '0');
	      call SysCurPos 23,53; call charout ,f12'r'f10'esume 'f12'p'f10'layback'
	      pauspl=1
	    end
	    else
	    do
  	      call SysCurPos 12,2+ElaPos; call charout ,f12''
              rc = mciRxSendString('resume m wait', 'RetStr', '0', '0');
	      call SysCurPos 23,53; call charout ,f12'p'f10'ause 'f12'p'f10'layback '
	      pauspl=0
	    end
	  end
        when AS=1 & plc='09'X | AS=3 & pls<>'00' then 	/* Wechseln zu Hauptschirm	*/
	  do
	    AS=0
	    call DisplayHead    
	    call AnzAktVerz AbspielDatei
	    call AnzPWD
	    call AnzCurBalk
	  end
        when AS=0 & (plc='09'X | plc='1b'X) then   /* Wechseln zu Abspielschirm	aus Hauptschirm */
	  do
	    AS=1
	    call WiederHerstPlay
	  end
        when AS=1 & pls='3B' then 	/* Wechseln zu Helpschirm	*/
	  do
	    AS=2			/* Help-Modus 			*/
	    call AnzHelpPlay
	  end
        when AS=2 & plst<>'00' then 	/* Wechseln zu Abspielschirm aus Helpschirm	*/
	  do
	    AS=1			/* Help-Modus 			*/
	    call WiederHerstPlay
	  end
        when AS=0 & plc='S' & SKpr=0 then call SavePlayList	9,40,f2,f25'.'	  /* S im Hauptschirm			*/
        when AS=1 & plc='S' & SKpr=0 then call SavePlayList	14,40,f11,f10'.'  /* S im Abspielschirm			*/
        when AS=0 & plc=' ' & DTyp.abspix='F' then call TagUntag iLied	/* <SPACE> bei MIDI-Datei (Tag/Untag Datei)	*/
        when AS=0 & plc='F' & SKpr=0 then call HZtogForever	/* F ohne Shift (Toggle Play Forever)		*/
        when AS=0 & pls='4B' then call HZleft	/* <LEFT> 			*/
	when AS=0 & (plc='0d'X | pls='4D') & DTyp.abspix<>'F' then	call HZchdir /* <ENTER> oder <RIGHT> bei Dir und Drive */
	when AS=0 & pls='50' then call HZdown	/* <DOWN>			*/
	when AS=0 & pls='48' then call HZup	/* <UP>				*/
	when AS=0 & pls='51' then call HZpgdn	/* <PGDN>			*/
	when AS=0 & pls='49' then call HZpgup	/* <PGUP>			*/
        when AS=0 & pls='47' then call HZhome	/* <HOME>			*/
        when AS=0 & pls='4F' then call HZend	/* <END>			*/
        when AS=0 & pls='3B' then call AZhelp	/* Wechseln zu Hilfeschirm	*/
        when plst<>'00' then 		/* berspringen nicht relevanter Zeichen */
	  nop
       	otherwise			/* abgelaufene Zeit anzeigen	*/
          call SysSleep 1
	  if pauspl=0 then
	  do
	    elaps=elaps+1
 	    if AS=1 then call AnzElaps
	  end
      end
      rc = mciRxSendString('status m mode wait', 'StatStr', '0', '0')
    end
    AbspielDatei=''
  end

  rc = mciRxSendString('close m wait', 'RetStr', '0', '0')
  if rc <> 0 then
  do
     MacRC = mciRxGetErrorString(rc, 'ErrStVar')
     say 'CLOSE: rc =' rc ', ErrStVar =' ErrStVar
     wt=SysGetKey(noecho)
  end

return

/* ----------------------------------------------------- */
/* Markieren/Entmarkieren von MIDI-Dateien zum Abspielen */
/* ----------------------------------------------------- */

TagUntag:

  parse arg tuiLied
  
  if DTag.ix=0 then DTag.ix=1
	       else DTag.ix=0
  if DTag.ix=1 then
  do
    DatTag.0=DatTag.0+1
    dtix=DatTag.0
    DatTag.dtix=Datei.ix
  end
  else
  do
    dtgef=0
    do dti=1 to DatTag.0
      dti1=dti+1
      if dtgef=0 & DatTag.dti=Datei.ix then do; dtgef=1; dtigef=dti; end
      if dtgef=1 & dtigef=tuiLied then dtgef=0	/* Lied wird gerade gespielt	*/
      if dtgef=1 then DatTag.dti=DatTag.dti1
    end
    if dtgef=1 then DatTag.0=DatTag.0-1
	       else DTag.ix=1
    if dtigef<tuilied then iLied=iLied-1
  end
  call AnzCurBalk
  /* Anzahl geTAGgter Dateien		*/
  call SysCurPos 5,3; call charout ,f5'xxxxx'
  call SysCurPos 5,8-length(DatTag.0); call charout ,f2||DatTag.0

return

TagUntagAllVerz:

  parse arg tuiLied
  
  dtTaggedAll=1						/* These: Alle Dateien sind getaggt	   */
  do dti=1 to dn					/* Prfen der These			   */
    if DTyp.dti="F" & DTag.dti=0 then dtTaggedAll=0	/* These ist doch falsch, da mind. 1 Datei */
  end							/* nicht getaggt			   */
  if dtTaggedAll=0 then		
  do dti=1 to dn
    if DTyp.dti="F" & DTag.dti=0 then
    do
      DTag.dti=1
      DatTag.0=DatTag.0+1
      dtix=DatTag.0
      DatTag.dtix=Datei.dti
    end
  end
  else
  do dti=1 to dn
    if DTyp.dti="F" & DTag.dti=1 then
    do
      DTag.dti=0
      dtgef=0
      do dtj=1 to DatTag.0
        dtj1=dtj+1
        if dtgef=0 & DatTag.dtj=Datei.dti then dtgef=1
        if dtgef=1 then DatTag.dtj=DatTag.dtj1
      end
      if dtgef=1 then DatTag.0=DatTag.0-1
    end
  end
  call AnzAktVerz ''
  call AnzCurBalk
  /* Anzahl geTAGgter Dateien		*/
  call SysCurPos 5,3; call charout ,f5'xxxxx'
  call SysCurPos 5,8-length(DatTag.0); call charout ,f2||DatTag.0

return

UntagAll:

  do uti=1 to dn
    DTag.uti=0
  end
  DatTag.0=0

return

/* ---------------------------------------------------- */
/* Anzeige der aktuell gespielten Zeit als Zahl und	*/
/* als Notensymbol im Fortschrittsbalken		*/
/* ---------------------------------------------------- */

AnzElaps:

  ElaSec=elaps//60+100; call SysCurPos 9,24; call charout ,f11||right(ElaSec,2)
  ElaMin=elaps%60
  if ElaMin<10 then do; call SysCurPos 9,22; call charout ,f11||ElaMin; end
	       else do; call SysCurPos 9,21; call charout ,f11||ElaMin; end
  ElaPos=76*elaps%LenPlay
  if ElaPos<>ElaPosA then
  do
    call SysCurPos 12,2+ElaPosA; call charout ,f19''
    if pauspl=0
      then do; call SysCurPos 12,2+ElaPos; call charout ,f12''; end
      else do; call SysCurPos 12,2+ElaPos; call charout ,f18''; end
    ElaPosA=ElaPos
  end
  
return

/* ---------------------------------------------------- */
/* Suchen Verzeichnisse, Dateien und Laufwerke ber	*/
/* Tastatureingabe (Shift-Key)				*/
/* ---------------------------------------------------- */

SuchVerzDatLw:
 
  parse arg SVDc

  SuchFeld=SuchFeld||SVDc
  do sui=1 to dn
    if DTyp.sui<>'V' then DatNam=translate(filespec('name',Datei.sui))
    		     else DatNam=translate(Datei.sui)
    if substr(DatNam,1,length(SuchFeld))=SuchFeld then
    do
      select
        when sui<ai then do; call ResCurBalk; ci=1; ai=sui; call AnzAktVerz ''; call AnzCurBalk; end
        when sui>ai+9 then do; call ResCurBalk; ci=10; ai=sui-9; call AnzAktVerz ''; call AnzCurBalk; end
        when sui<>ai+ci-1 then do; call ResCurBalk; ci=sui-ai+1; call AnzAktVerz ''; call AnzCurBalk; end
        otherwise
      end
      leave
    end
  end
  call SysCurPos 23,20; 
  if length(Suchfeld)>8 then sui=dn+1
  if SVDc<>'' then
  do
    if sui=dn+1 then do; SuchFeld=''; call charout ,f5''; end
	        else do; call charout ,f4' Search 'f21'['f20||left(Suchfeld,8)||f21'] '; end
  end
return

AnzPlayForeverRandom:

  call SysCurPos 22,23
  select
    when PlayForever=1 & PlayRandom=1 then
      call charout ,f2' (random playback / play forever) '
    when PlayForever=1 then
      call charout ,f1' 'f2'(play forever)'f1' '
    when PlayRandom=1 then
      call charout ,f1' 'f2'(random playback)'f1' '
    otherwise
      call charout ,f1''
  end

return

Mischen:

  do mii=1 to DatTag.0		/* Initialisieren Hilfsvektor RV			*/
    RV.mii=''
  end
  do mii=1 to DatTag.0		/* Zuflliges Fllen mit Inhalt aus Vektor DatTag	*/
    do until RV.mix=''
      mix=random(1,DatTag.0)
    end
    RV.mix=DatTag.mii
  end
  do mii=1 to DatTag.0		/* Rckschreiben in Vektor DatTag			*/
    DatTag.mii=RV.mii
  end

  
return

HZdown:
      do
        if ci<10 & ai-1+ci<dn then do; call ResCurBalk; ci=ci+1; call AnzCurBalk; end
        else
        if ai+9<dn then do; ai=ai+1; call AnzAktVerz Abspieldatei; call AnzCurBalk; end
      end
return

HZup:
      do
        if ci>1 then do; call ResCurBalk; ci=ci-1; call AnzCurBalk; end
        else
        if ai>1 then do; ai=ai-1; call AnzAktVerz AbspielDatei; call AnzCurBalk; end
      end
return

HZpgdn:
      do
        if ai+9<dn then do; ci=1; ai=ai+10; call AnzAktVerz AbspielDatei; call AnzCurBalk; end
      end
return

HZpgup:
      do
        if ai>1 then do; ci=1; ai=max(1,ai-10); call AnzAktVerz AbspielDatei; call AnzCurBalk; end
      end
return

HZchdir:
  do
    if SuchFeld<>'' then do; SuchFeld=''; call SysCurPos 23,20; call charout ,f5''; end
    ix=ai-1+ci
    if DTyp.ix='D' then call directory word(datei.ix,1)
		   else call directory word(datei.ix,1)'\'
    if ix=1 then		/* cd ..					*/
    do
      call LesAktVerz
      SuchFeld=translate(filespec('name',AktDir))
      call SuchVerzDatLw ''	/* Einstellen des Herkunftsverzeichnis		*/
      SuchFeld=''
      call AnzPWD
    end
    else 			/* wechsle in Unterverzeichnis			*/
    do
      call LesAktVerz
      call AnzPWD
      ai=1			/* erster anzuzeigender Verzeichniseintrag	*/
      call AnzAktVerz AbspielDatei
      ci=1			/* Position Balken-Cursor			*/
      call AnzCurBalk
    end
  end
return

HZleft:
  ai=1; ci=1			/* Werte, damit ix auf 1 gesetzt wird		*/
  call HZchdir
return

HZhome:
      do
        if ai>1 then do; ci=1; ai=1; call AnzAktVerz AbspielDatei; call AnzCurBalk; end
        else
        if ci>1 then do; call ResCurBalk; ci=1; call AnzCurBalk; end
      end
return

HZend:
      do
        if dn>10 then do; ci=10; ai=dn-9; call AnzAktVerz AbspielDatei; call AnzCurBalk; end
        else
        if ci<dn then do; call ResCurBalk; ci=dn; call AnzCurBalk; end
      end
return

HZtogForever:
      do
        if PlayForever=0 then PlayForever=1
		         else PlayForever=0
	call AnzPlayForeverRandom
      end
return

HZtogRandom:
      do
        if PlayRandom=0 then PlayRandom=1
		        else PlayRandom=0
	call AnzPlayForeverRandom
      end
return

HZhelp:			/* Wechseln zu Hilfeschirm	*/
      do
        HS=2
	call AnzHauptHilfe
      end
return

AZhelp:			/* Wechseln zu Hilfeschirm	*/
      do
        AS=3
	call AnzHauptHilfe
      end
return

LoadPlayList:		/* Laden der Playlist aus einer Datei	*/
			/* Parameter: Zeile, Lnge, Zeichenfarbe, Fllzeichen */
	parse arg lpLine, lpLen, lpColor, lpFill
	do
	  call SysCurPos lpLine,3; call charout ,f2'playlist filename: 'f25||copies('.',40)
          call SysCurPos lpLine,22
          PListName = ReadKbdString(lpLen, lpColor, lpFill)
	  if PListName <> '' then
	  do
	    call UntagAll
            spli=0 
	    rc=stream(PListName, "C", "OPEN READ")
	    do while lines(PListName)>0
	      spli=spli+1
	      DatTag.spli=linein(PListName)
            end
	    DatTag.0=spli
	    rc=stream(PListName, "C", "CLOSE")
	  end
          call SysCurPos lpLine,3; call charout ,copies(' ',70)
	  call LesAktVerz
	  call DisplayHead    
	  call AnzAktVerz ''
	  call AnzPWD
	  call AnzCurBalk
	end
return 

SavePlayList:		/* Sichern der Playlist in eine Datei	*/
			/* Parameter: Zeile, Lnge, Zeichenfarbe, Fllzeichen */
	parse arg spLine, spLen, spColor, spFill
	if DatTag.0>0 then
	do
	  call SysCurPos spLine,3; call charout ,spColor'playlist filename: 'copies(spFill,40)
          call SysCurPos spLine,22
          PListName = ReadKbdString(spLen, spColor, spFill)
	  if PListName <> '' then
	  do
	    '@DEL 'PListName' 1>nul 2>nul '
	    rc=stream(PListName, "C", "OPEN WRITE")
	    do spli=1 to DatTag.0
	      call lineout PListName, DatTag.spli
            end
	    rc=stream(PListName, "C", "CLOSE")
	  end
          call SysCurPos spLine,3; call charout ,copies(' ',70)
	end
return 

ClearPlayList:		/* Laden der Playlist aus einer Datei	*/
	call UntagAll
	DatTag.0=0
	call LesAktVerz
	call DisplayHead    
	call AnzAktVerz ''
	call AnzPWD
	call AnzCurBalk
return 

ReadKbdString:		/* Eingabe einer Zeichenkette ber Tastatur    */
			/* Parameter: Lnge, Zeichenfarbe, Fllzeichen */
	parse arg rksLen, rksColor, rksFill
	rksBuf=''	/* Eingabepuffer 			*/
	rksBufL=0	/* aktuelle Lnge Eingabepuffer 	*/
	rksi=0		/* Eingabeposition im Eingabepuffer 	*/
        call SysCurState 'ON'
	do until rksc='03'X | rksc='1B'X | rksc='0D'X
	  parse value SysCurPos() with rksZeile rksSpalte
	  KeyStr = RxKbdCharIn(wait)		/* Eingabe eines Zeichens ohne Echo mit Auswertung Scancode */
  	  if substr(KeyStr,2,2)='  ' then 
	  do
    	    rksc=word(KeyStr,1)			/* eingegebenes Zeichen 	*/
    	    rkss=translate(word(KeyStr,2))	/* eingegebener Scancode	*/
    	    rkssk=word(KeyStr,5)
  	  end
  	  else 
  	  do
    	    rksc=word(KeyStr,2)			/* eingegebenes Zeichen 	*/
    	    rkss=translate(word(KeyStr,3))	/* eingegebener Scancode	*/
    	    rkssk=word(KeyStr,6)
  	  end
  	  if substr(KeyStr,2,3)='   ' then rksc=' '
          select
	    when rksc='03'X | rksc='1B'X then	/* Abbruch der Eingabe		*/
	      rksBuf=''
	    when rksc='0D'X then		/* Beenden der Eingabe		*/
	      nop
	    when rksc>' ' & rksc<='z' then	/* Zeichen fr Dateiname	*/
	      if rksBufL<rksLen then 
	      do
   		if rksi=rksBufL then
		do				/* Zeichen anhngen		*/
		  rksBuf=rksBuf||rksc
		  rksBufL=rksBufL+1; rksi=rksi+1
		  call charout ,rksColor||rksc
		  /*if rksi>=rksLen then call SysCurPos rksZeile, rksSpalte */
		end
		else
		do				/* Zeichen einfgen		*/
		  rksBuf=insert(rksc,rksBuf,rksi)	
		  rksBufL=rksBufL+1; rksi=rksi+1
		  call charout ,rksColor||substr(rksBuf,rksi)
		  call SysCurPos rksZeile, rksSpalte+1
		end
	      end
	    when rkss='53' then			/* DEL		    */
	      if rksi>=0 & rksi<rksBufL then
	      do
		rksBuf=delstr(rksBuf,rksi+1,1)
		call charout ,rksColor||substr(rksBuf,rksi+1)||rksFill
		rksBufL=rksBufL-1
		call SysCurPos rksZeile, rksSpalte
	      end
	    when rkss='0E' | rksc='08'X then			/* ^H		    */
	      if rksi>0 then
	      do
		rksBuf=delstr(rksBuf,rksi,1)
		call SysCurPos rksZeile, rksSpalte-1
		call charout ,rksColor||substr(rksBuf,rksi)||rksFill
		rksBufL=rksBufL-1; rksi=rksi-1
		call SysCurPos rksZeile, rksSpalte-1
	      end
	    when rkss='4B' then			/* Pfeil nach links */
	      if rksi>0 then do; rksi=rksi-1; call SysCurPos rksZeile, rksSpalte-1; end
	    when rkss='4D' then			/* Pfeil nach rechts */
	      if rksi<rksBufl /*& rksi<rksLen*/ then do; rksi=rksi+1; call SysCurPos rksZeile, rksSpalte+1; end
    	    otherwise
          end
        end
	call SysCurState 'OFF'
return rksBuf

AnzHelpPlay:

  call SysCls
  say f13'    %,    %,         '
  say f13'     %%     %        '
  say f13'     %%%,    %,      '
  say f13"     %%%'%    %%     "
  say f13"     %%% '%. .%%%    "
  say f13'    %%%%   % % %%%   '
  say f13'    %%%%   %%%  %%%  '
  say f13'   %%%%%   %%   %%%% '
  say f13'  %%%%%    %%   %%%% '
  say f13'.%%%%%    .%%  .%%%% '
  say f13"%%%%%     %%'  %%%%' "
  yp=0
  yp=yp+0; call SysCurPos yp,23; call charout ,f12'- 'f18'c o m m a n d  l i s t i n g 'f12'-'
  yp=yp+2; call SysCurPos yp,23; call charout ,f23'p 'f24'l a y b a c k  'f23'f 'f24'u n c t i o n s'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'n'f16'. 'f0'next song'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'p'f16'. 'f0'previous song'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'q'f16'. 'f0'quit to the tagger (clears the playlist)'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'space'f16'. 'f0'pause playback'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'tab'f16'. 'f0'go to the tagger (while playing)'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'<>'f16'. 'f0'skip backward/forward 5 seconds'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'<- ->'f16'. 'f0'change the volume'
  yp=yp+2; call SysCurPos yp,23; call charout ,f23'm 'f24'i s c.  'f23's 'f24't u f f'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10's'f16'. 'f0'save playlist'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'<del>'f16'. 'f0'delete file'
           call SysCurPos yp,63; call charout ,f18'(not implemented)'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'alt-p'f16'. 'f0'playlist editor'
           call SysCurPos yp,63; call charout ,f18'(not implemented)'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'alt-r'f16'. 'f0'randomize the unplayed tracks'
           call SysCurPos yp,63; call charout ,f18'(not implemented)'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'b'f16'. 'f0"same as q but doesn't clear playlist"
  call SysCurPos 24,67; call charout ,f0'<hit a key!>'

return

AnzHauptHilfe:

  call SysCls
  say f13'    %,    %,         '
  say f13'     %%     %        '
  say f13'     %%%,    %,      '
  say f13"     %%%'%    %%     "
  say f13"     %%% '%. .%%%    "
  say f13'    %%%%   % % %%%   '
  say f13'    %%%%   %%%  %%%  '
  say f13'   %%%%%   %%   %%%% '
  say f13'  %%%%%    %%   %%%% '
  say f13'.%%%%%    .%%  .%%%% '
  say f13"%%%%%     %%'  %%%%' "
  yp=0
  yp=yp+0; call SysCurPos yp,23; call charout ,f12'- 'f18'c o m m a n d  l i s t i n g 'f12'-'
  yp=yp+2; call SysCurPos yp,23; call charout ,f23'p 'f24'l a y l i s t  'f23'f 'f24'u n c t i o n s'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'l. 'f11'load playlist'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10's. 'f11'save playlist'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'c. 'f11'clear playlist/tagged files'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'alt-p. 'f11'playlist editor'
           call SysCurPos yp,63; call charout ,f18'(not implemented)'
  yp=yp+2; call SysCurPos yp,23; call charout ,f23't 'f24'a g g i n g  'f23'o 'f24'p t i o n s'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10' . 'f11'move up and down'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'space. 'f11'tag file to play'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'alt-r. 'f11'recurse into sub-dir and tag all'
           call SysCurPos yp,63; call charout ,f18'(not implemented)'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'a. 'f11'tag all files'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'r. 'f11'toggle random playback'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'f. 'f11'toggle forever play'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'p. 'f11'play tagged files'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'tab. 'f11'return to playscreen (if playing)'
  yp=yp+2; call SysCurPos yp,23; call charout ,f23'm 'f24'i s c.  'f23's 'f24't u f f'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'q. 'f11'quit m! (or return to mainscreen)'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'n. 'f11'rename file'
           call SysCurPos yp,63; call charout ,f18'(not implemented)'
  yp=yp+1; call SysCurPos yp,23; call charout ,f10'shift-X. 'f11'goes to 1st file in the listing starting with'
  yp=yp+1; call SysCurPos yp,32; call charout  ,f11'character "X"'
  call SysCurPos 24,67; call charout ,f0'<hit a key!>'

return

WiederHerstPlay:
	    call DisplayHeadPlay iLied
	    call SysCurPos 8,24; call charout ,f11||substr(LenSec,2,2)
	    if LenMin<10 then do; call SysCurPos 8,22; call charout ,f11||LenMin; end
	    		 else do; call SysCurPos 8,21; call charout ,f11||LenMin; end
	    call SysCurPos 5,5; call charout ,f11||filespec("name",AbspielDatei)
	    call SysCurPos 8,59; call charout ,f11||right(volume,3)
	    call SysCurPos 9,52; call charout ,v.volume
	    call AnzElaps
return

